// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
    using System.Collections.Generic;
    using Eco.Core.Items;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;

    [Serialized]
    [LocDisplayName("Baked Coffee Beans")]
    [MaxStackSize(100)]
    [Weight(1)]
    [Ecopedia("Food", "Baking", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    public partial class BakedCoffeeBeansItem : FoodItem
    {
        public override LocString DisplayNamePlural     => Localizer.DoStr("BakedCoffeeBeans");
        public override LocString DisplayDescription    => Localizer.DoStr("Coffee beans ready to make coffee.");
        
        public override float Calories                  => 850;
        public override Nutrients Nutrition             => new Nutrients() { Carbs = 1, Fat = 0, Protein = 0, Vitamins = 1};
    }

    [RequiresSkill(typeof(AdvancedBakingSkill), 2)]
    public partial class BakedCoffeeBeansRecipe :
        RecipeFamily
    {
        public BakedCoffeeBeansRecipe()
        {
            var product = new Recipe(
                "BakedCoffeeBeans",
                Localizer.DoStr("Baked Coffee Beans"),
                new IngredientElement[]
                {
                    new IngredientElement(typeof(CoffeeBeanItem), 4, typeof(AdvancedBakingSkill), typeof(AdvancedBakingLavishResourcesTalent)),
                },
                new CraftingElement<BakedCoffeeBeansItem>(1)
                );

            this.Recipes = new List<Recipe> { product };
            this.LaborInCalories = CreateLaborInCaloriesValue(20, typeof(AdvancedBakingSkill));
            this.CraftMinutes = CreateCraftTimeValue(typeof(BakedCoffeeBeansRecipe), 3, typeof(AdvancedBakingSkill), typeof(AdvancedBakingFocusedSpeedTalent), typeof(AdvancedBakingParallelSpeedTalent));
            this.ModsPreInitialize();
            this.Initialize(Localizer.DoStr("Baked Coffee Beans"), typeof(BakedCoffeeBeansRecipe));
            this.ModsPostInitialize();
            CraftingComponent.AddRecipe(typeof(BakeryOvenObject), this);
        }

        /// <summary>Hook for mods to customize RecipeFamily before initialization. You can change recipes, xp, labor, time here.</summary>
        partial void ModsPreInitialize();
        /// <summary>Hook for mods to customize RecipeFamily after initialization, but before registration. You can change skill requirements here.</summary>
        partial void ModsPostInitialize();
    }
}
