// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
    using System.Collections.Generic;
    using Eco.Core.Items;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;

    [Serialized]
    [LocDisplayName("Caesar Salad")]
    [MaxStackSize(100)]
    [Weight(1)]
    [Ecopedia("Food", "Cooking", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    public partial class CaesarSaladItem : FoodItem
    {
        public override LocString DisplayDescription    => Localizer.DoStr("Salad to go.");
        
        public override float Calories                  => 1050;
        public override Nutrients Nutrition             => new Nutrients() { Carbs = 22, Fat = 16, Protein = 11, Vitamins = 26};
    }

    [RequiresSkill(typeof(CuttingEdgeCookingSkill), 4)]
    public partial class CaesarSaladRecipe :
        RecipeFamily
    {
        public CaesarSaladRecipe()
        {
            var product = new Recipe(
                "CaesarSalad",
                Localizer.DoStr("Caesar Salad"),
                new IngredientElement[]
                {
                    new IngredientElement(typeof(BasicSaladItem), 1, true), 
                    new IngredientElement(typeof(InfusedOilItem), 4, typeof(CuttingEdgeCookingSkill), typeof(CuttingEdgeCookingLavishResourcesTalent)),
                    new IngredientElement(typeof(HydrocolloidsItem), 2, typeof(CuttingEdgeCookingSkill), typeof(CuttingEdgeCookingLavishResourcesTalent)),
                    new IngredientElement(typeof(MaltodextrinItem), 1, typeof(CuttingEdgeCookingSkill), typeof(CuttingEdgeCookingLavishResourcesTalent)),   
                },
                new CraftingElement<CaesarSaladItem>(2)
                );

            this.Recipes = new List<Recipe> { product };
            this.LaborInCalories = CreateLaborInCaloriesValue(20, typeof(CuttingEdgeCookingSkill));
            this.CraftMinutes = CreateCraftTimeValue(typeof(CaesarSaladRecipe), 6, typeof(CuttingEdgeCookingSkill), typeof(CuttingEdgeCookingFocusedSpeedTalent), typeof(CuttingEdgeCookingParallelSpeedTalent));
            this.ModsPreInitialize();
            this.Initialize(Localizer.DoStr("Caesar Salad"), typeof(CaesarSaladRecipe));
            this.ModsPostInitialize();
            CraftingComponent.AddRecipe(typeof(FoodAssemblyLineObject), this);
        }

        /// <summary>Hook for mods to customize RecipeFamily before initialization. You can change recipes, xp, labor, time here.</summary>
        partial void ModsPreInitialize();
        /// <summary>Hook for mods to customize RecipeFamily after initialization, but before registration. You can change skill requirements here.</summary>
        partial void ModsPostInitialize();
    }
}
