// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
    using System.Collections.Generic;
    using Eco.Core.Items;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;

    [Serialized]
    [LocDisplayName("Espresso")]
    [MaxStackSize(100)]
    [Weight(1)]
    [Ecopedia("Food", "Cooking", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    public partial class EspressoItem : FoodItem
    {
        public override LocString DisplayNamePlural     => Localizer.DoStr("Espresso");
        public override LocString DisplayDescription    => Localizer.DoStr("Some call it the magic potion.");
        
        public override float Calories                  => 2500;
        public override Nutrients Nutrition             => new Nutrients() { Carbs = 8, Fat = 1, Protein = 5, Vitamins = 10};
    }

[RequiresSkill(typeof(AdvancedBakingSkill), 2)]
    public partial class EspressoRecipe :
        RecipeFamily
    {
        public EspressoRecipe()
        {
            var product = new Recipe(
                "Espresso",
                Localizer.DoStr("Espresso"),
                new IngredientElement[]
                {
                    new IngredientElement(typeof(BakedCoffeeBeansItem), 2, typeof(AdvancedCookingSkill), typeof(AdvancedCookingLavishResourcesTalent)),
                },
                new CraftingElement<EspressoItem>(1)
                );

            this.Recipes = new List<Recipe> { product };
            this.LaborInCalories = CreateLaborInCaloriesValue(20);
            this.CraftMinutes = CreateCraftTimeValue(typeof(EspressoRecipe), 3, typeof(AdvancedCookingSkill), typeof(AdvancedCookingFocusedSpeedTalent), typeof(AdvancedCookingParallelSpeedTalent));
            this.ModsPreInitialize();
            this.Initialize(Localizer.DoStr("Espresso"), typeof(EspressoRecipe));
            this.ModsPostInitialize();
            CraftingComponent.AddRecipe(typeof(BakeryOvenObject), this);
        }

        /// <summary>Hook for mods to customize RecipeFamily before initialization. You can change recipes, xp, labor, time here.</summary>
        partial void ModsPreInitialize();
        /// <summary>Hook for mods to customize RecipeFamily after initialization, but before registration. You can change skill requirements here.</summary>
        partial void ModsPostInitialize();
    }
}
