// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
    using System.Collections.Generic;
    using Eco.Core.Items;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;

    [Serialized]
    [LocDisplayName("Hot Wings")]
    [MaxStackSize(100)]
    [Weight(1)]
    [Ecopedia("Food", "Cooking", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    public partial class HotWingsItem : FoodItem
    {
        public override LocString DisplayDescription    => Localizer.DoStr("Finger licking good!");
        
        public override float Calories                  => 1250;
        public override Nutrients Nutrition             => new Nutrients() { Carbs = 10, Fat = 19, Protein = 32, Vitamins = 10};
    }

    [RequiresSkill(typeof(CuttingEdgeCookingSkill), 5)]
    public partial class HotWingsRecipe :
        RecipeFamily
    {
        public HotWingsRecipe()
        {
            var product = new Recipe(
                "HotWings",
                Localizer.DoStr("Hot Wings"),
                new IngredientElement[]
                {
                    new IngredientElement(typeof(PreparedMeatItem), 4, typeof(CuttingEdgeCookingSkill), typeof(CuttingEdgeCookingLavishResourcesTalent)), 
                    new IngredientElement(typeof(CornStarchItem), 4, typeof(CuttingEdgeCookingSkill), typeof(CuttingEdgeCookingLavishResourcesTalent)),
                    new IngredientElement(typeof(BreadItem), 4, typeof(CuttingEdgeCookingSkill), typeof(CuttingEdgeCookingLavishResourcesTalent)),
                    new IngredientElement(typeof(HydrocolloidsItem), 2, typeof(CuttingEdgeCookingSkill), typeof(CuttingEdgeCookingLavishResourcesTalent)),
                    new IngredientElement(typeof(TransglutaminaseItem), 2, typeof(CuttingEdgeCookingSkill), typeof(CuttingEdgeCookingLavishResourcesTalent)),   
                },
                new CraftingElement<HotWingsItem>(2)
                );

            this.Recipes = new List<Recipe> { product };
            this.LaborInCalories = CreateLaborInCaloriesValue(20, typeof(CuttingEdgeCookingSkill));
            this.CraftMinutes = CreateCraftTimeValue(typeof(HotWingsRecipe), 6, typeof(CuttingEdgeCookingSkill), typeof(CuttingEdgeCookingFocusedSpeedTalent), typeof(CuttingEdgeCookingParallelSpeedTalent));
            this.ModsPreInitialize();
            this.Initialize(Localizer.DoStr("Hot Wings"), typeof(HotWingsRecipe));
            this.ModsPostInitialize();
            CraftingComponent.AddRecipe(typeof(FoodAssemblyLineObject), this);
        }

        /// <summary>Hook for mods to customize RecipeFamily before initialization. You can change recipes, xp, labor, time here.</summary>
        partial void ModsPreInitialize();
        /// <summary>Hook for mods to customize RecipeFamily after initialization, but before registration. You can change skill requirements here.</summary>
        partial void ModsPostInitialize();
    }
}
